// eff3.cpp: implementation of the eff3 class.
//
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <memory.h>
#include <math.h>
#include <stdlib.h>
#include "ptc.h"
#include "3d1.h"
#include "eff3.h"

#define max_x 319
#define max_y 199
#define min_x 0
#define min_y 0

extern void Vpcxloada(int velikost,char *dest,char *src,int dimsrc);
extern unsigned char pcxpalette[768];

#include "textura.dat"

//include  eff3::cube(object3d* objp)
#include "eff3cube.cpp"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

eff3::eff3()
{
 strcpy(m_name,"3D2");  
 m_framecnt=0;
 //setup for 3d rotation
 incz=1,pocet=0;   
 light.x=0;
 light.y=0;
 light.z=-1;
 cam.x=0;
 cam.y=0;
 cam.z=400;
 sincosini();
 cube(&obj);
 for(pocet=1;pocet<=obj.Npolys;pocet++)
 obj.polys[pocet].textura=(unsigned char*)textrdata;
 Ginitnorm(&obj,&light,&lightn);
 preptexture(&obj);
 pocet=0;
}

eff3::~eff3()
{

}

void eff3::genpal(){
 int         col;
 int32 *paldata = palette.lock();
 
 memset(textrdata,0,128*128);
 Vpcxloada(128*128,(char*)textrdata,(char*)tdata,sizeof(tdata)); 
 for(col=0;col<256;col++)
  {
   paldata[col]=pack(pcxpalette[col*3],
	                 pcxpalette[(col*3)+1],
                     pcxpalette[(col*3)+2]);
  }
  // unlock palette
  palette.unlock();
}

void eff3::preptexture(object3D *objp)
{ 
//int i;
//int vert1,vert2,vert3;
//int tempu,tempv;
 
/* for(i=1;i<=objp->Npolys;i++)
 {
  vert1=objp->polys[i].whichvertexes[1];
  vert2=objp->polys[i].whichvertexes[2];
  vert3=objp->polys[i].whichvertexes[3];
  tempu=((int)(objp->vertnorm[vert1].x)*256)/2;
  tempv=((int)(objp->vertnorm[vert1].y)*256)/2;
  clip(&tempu,&tempv);
  objp->polys[i].textrpoints[1].x=tempu;
  objp->polys[i].textrpoints[1].y=tempv;
  tempu=((int)(objp->vertnorm[vert2].x)*256) / 2;
  tempv=((int)(objp->vertnorm[vert2].y)*256) / 2;
  clip(&tempu,&tempv);
  objp->polys[i].textrpoints[2].x=tempu;
  objp->polys[i].textrpoints[2].y=tempv;
  tempu=((int)(objp->vertnorm[vert3].x)*256) / 2;
  tempv=((int)(objp->vertnorm[vert3].y)*256) / 2;
  clip(&tempu,&tempv);
  objp->polys[i].textrpoints[3].x=tempu;
  objp->polys[i].textrpoints[3].y=tempv;
 }*/
  objp->polys[12].textrpoints[1].x=0;
  objp->polys[12].textrpoints[1].y=127;

  objp->polys[12].textrpoints[2].x=127;
  objp->polys[12].textrpoints[2].y=0;

  objp->polys[12].textrpoints[3].x=127;
  objp->polys[12].textrpoints[3].y=127;

  objp->polys[11].textrpoints[1].x=0;
  objp->polys[11].textrpoints[1].y=127;

  objp->polys[11].textrpoints[2].x=0;
  objp->polys[11].textrpoints[2].y=0;

  objp->polys[11].textrpoints[3].x=127;
  objp->polys[11].textrpoints[3].y=0;

  objp->polys[10].textrpoints[1].x=0;
  objp->polys[10].textrpoints[1].y=0;

  objp->polys[10].textrpoints[2].x=127;
  objp->polys[10].textrpoints[2].y=127;

  objp->polys[10].textrpoints[3].x=0;
  objp->polys[10].textrpoints[3].y=127;

  objp->polys[9].textrpoints[1].x=0;
  objp->polys[9].textrpoints[1].y=0;

  objp->polys[9].textrpoints[2].x=127;
  objp->polys[9].textrpoints[2].y=0;

  objp->polys[9].textrpoints[3].x=127;
  objp->polys[9].textrpoints[3].y=127;
  
  objp->polys[8].textrpoints[1].x=127;
  objp->polys[8].textrpoints[1].y=0;

  objp->polys[8].textrpoints[2].x=0;
  objp->polys[8].textrpoints[2].y=127;

  objp->polys[8].textrpoints[3].x=0;
  objp->polys[8].textrpoints[3].y=0;

  objp->polys[7].textrpoints[1].x=127;
  objp->polys[7].textrpoints[1].y=0;

  objp->polys[7].textrpoints[2].x=127;
  objp->polys[7].textrpoints[2].y=127;

  objp->polys[7].textrpoints[3].x=0;
  objp->polys[7].textrpoints[3].y=127;

  objp->polys[6].textrpoints[1].x=127;
  objp->polys[6].textrpoints[1].y=127;

  objp->polys[6].textrpoints[2].x=0;
  objp->polys[6].textrpoints[2].y=0;

  objp->polys[6].textrpoints[3].x=127;
  objp->polys[6].textrpoints[3].y=0;
 
  objp->polys[5].textrpoints[1].x=127;
  objp->polys[5].textrpoints[1].y=127;

  objp->polys[5].textrpoints[2].x=0;
  objp->polys[5].textrpoints[2].y=127;

  objp->polys[5].textrpoints[3].x=0;
  objp->polys[5].textrpoints[3].y=0;

  objp->polys[4].textrpoints[1].x=127;
  objp->polys[4].textrpoints[1].y=0;

  objp->polys[4].textrpoints[2].x=0;
  objp->polys[4].textrpoints[2].y=127;

  objp->polys[4].textrpoints[3].x=0;
  objp->polys[4].textrpoints[3].y=0;

  objp->polys[3].textrpoints[1].x=127;
  objp->polys[3].textrpoints[1].y=0;

  objp->polys[3].textrpoints[2].x=127;
  objp->polys[3].textrpoints[2].y=127;

  objp->polys[3].textrpoints[3].x=0;
  objp->polys[3].textrpoints[3].y=127;

  objp->polys[2].textrpoints[1].x=127;
  objp->polys[2].textrpoints[1].y=127;

  objp->polys[2].textrpoints[2].x=0;
  objp->polys[2].textrpoints[2].y=0;

  objp->polys[2].textrpoints[3].x=127;
  objp->polys[2].textrpoints[3].y=0;

  objp->polys[1].textrpoints[1].x=127;
  objp->polys[1].textrpoints[1].y=127;

  objp->polys[1].textrpoints[2].x=0;
  objp->polys[1].textrpoints[2].y=127;

  objp->polys[1].textrpoints[3].x=0;
  objp->polys[1].textrpoints[3].y=0;

}

void eff3::play(void){

  uppgradeobject(&obj);
  Gzxyrout(&obj);
  perspektive(&obj);
  Greadin(&obj);
  textrputpolys(&obj);
  if ((m_framecnt%2)==0){
   pocet++;
   obj.objpos.z-=incz*2;
  }
  if (pocet==70) incz=(-1)*incz,pocet=0;
  if (m_framecnt==400){
   obj.degreinc.x=2;
   obj.degreinc.y=1;
  }
  if (m_framecnt>400 && m_framecnt<900){
   printspr(1,38,155,51,100,20,240,mp_pixels);
   printspr(159,42,211,51,140,44,240,mp_pixels);
  }
  m_framecnt++;
  //if (frame_cnt>1500)  fadedownpal(1),setpalette();
}


void eff3::textrputpolys(object3D *objp)
{
 int cispol;
 int i;

 QUICKSORT(1,numshow,objp);
 for(i=numshow;i>=1;i--)
   {
    cispol=objp->sortdata.sortlist[i][0];   /*cislo setrideneho polygonu*/
    if (objp->polys[cispol].hidden==2)  /*je videt ci ne*/
     {
      texpolygon(&(objp->polys[cispol]),mp_pixels);
     }
   }
}


void eff3::texpolygon(polygon *txtpoly,char8* where)
/* souradnice x,y na obrazovce
   souradnice u,v v texture */  
{
 int x1,y1,x2,y2,x3,y3,u1,v1,u2,v2,u3,v3; 
 int deltx,deltu,deltv;
 int xintr,uintr,vintr;
 int Cnty;

 x1=txtpoly->cornerpoints[1].x;
 y1=txtpoly->cornerpoints[1].y;
 x2=txtpoly->cornerpoints[2].x;
 y2=txtpoly->cornerpoints[2].y;
 x3=txtpoly->cornerpoints[3].x;
 y3=txtpoly->cornerpoints[3].y;
 
 u1=txtpoly->textrpoints[1].x;
 v1=txtpoly->textrpoints[1].y;
 u2=txtpoly->textrpoints[2].x;
 v2=txtpoly->textrpoints[2].y;
 u3=txtpoly->textrpoints[3].x;
 v3=txtpoly->textrpoints[3].y;
 
 if(y1>y2) 
  {
   xchange2(&x1,&x2,&y1,&y2);
   xchange2(&u1,&u2,&v1,&v2);
  }  

 if(y1>y3) 
  {
   xchange2(&x1,&x3,&y1,&y3);
   xchange2(&u1,&u3,&v1,&v3);
  }  

 if(y2>y3) 
  {
   xchange2(&x2,&x3,&y2,&y3);
   xchange2(&u2,&u3,&v2,&v3);
  }  


 if (!(y2-y1)) deltx=0,deltu=0,deltv=0;   // priprava interpl. kroku
   else 
   { deltx=((x2-x1)<<16)/(y2-y1);
     deltu=((u2-u1)<<16)/(y2-y1);
     deltv=((v2-v1)<<16)/(y2-y1);
    } 
 xintr=x1<<16;                     //interpolace x,u,v podle y
 uintr=u1<<16;
 vintr=v1<<16;
 for(Cnty=y1;Cnty<=y2;Cnty++)
  { if ((Cnty>0) && (Cnty<max_y))    //protoze neklipuji, aby nepreteklo pole!!!!
    {
     Edge1[Cnty][0]=xintr>>16;
     Edge1[Cnty][1]=uintr>>16;       // pro hranu 2-1
     Edge1[Cnty][2]=vintr>>16;
    }
    xintr+=deltx;
    uintr+=deltu;
    vintr+=deltv;  
  } 
 
 if (!(y3-y1)) deltx=0,deltu=0,deltv=0;   //priprava interpolacnich kroku
  else 
   { deltx=((x3-x1)<<16)/(y3-y1);
     deltu=((u3-u1)<<16)/(y3-y1);
     deltv=((v3-v1)<<16)/(y3-y1);
    } 
 xintr=x1<<16;                     //interpolace x,u,v podle y
 uintr=u1<<16;
 vintr=v1<<16;
 for(Cnty=y1;Cnty<=y3;Cnty++)
  {if ((Cnty>0) && (Cnty<max_y))
    {
     Edge2[Cnty][0]=xintr>>16;       //  pro hranu 3-1
     Edge2[Cnty][1]=uintr>>16;
     Edge2[Cnty][2]=vintr>>16;
    }
   xintr+=deltx;
   uintr+=deltu;
   vintr+=deltv;
  } 

 if (!(y3-y2)) deltx=0,deltu=0,deltv=0;   //priprava interpolacnich kroku
  else 
   { deltx=((x3-x2)<<16)/(y3-y2);
     deltu=((u3-u2)<<16)/(y3-y2);
     deltv=((v3-v2)<<16)/(y3-y2);
    } 
 xintr=x2<<16;                     //interpolace x,u,v podle y
 uintr=u2<<16;
 vintr=v2<<16;
 for(Cnty=y2;Cnty<=y3;Cnty++)
  {
   if ((Cnty>0) && (Cnty<max_y))
    {
     Edge1[Cnty][0]=xintr>>16;       //  pro hranu 3-2
     Edge1[Cnty][1]=uintr>>16;
     Edge1[Cnty][2]=vintr>>16;
     }
    xintr+=deltx;
    uintr+=deltu;
    vintr+=deltv;
  }

/*cliping souradnice y*/
 if(y1<min_y) y1=min_y;
 if(y1>max_y) return;
 if(y3>max_y) y3=max_y;
 if(y3<min_y) return;


 /*mame pripraveny pole s nainterpolovanejma x u v podle y
   a deme kreslit scanlajny, pri vykreslovani scaline
  interpoluju u,v v texture podle x ve scanline
   bod precteny z textury na u,v zapisu na x,y na obrazovku*/
 /* JE to vlastne procedura texturehline*/
 for(Cnty=y1;Cnty<=y3;Cnty++)
 {int xh1,xh2,uh1,uh2,vh1,vh2; 
  int deltuH,deltvH;
  int Cntx;
  unsigned char color;
    
  xh1=Edge1[Cnty][0];
  xh2=Edge2[Cnty][0];
  uh1=Edge1[Cnty][1];
  uh2=Edge2[Cnty][1];
  vh1=Edge1[Cnty][2];
  vh2=Edge2[Cnty][2];
  if(xh1>xh2) xchange(&xh1,&xh2,&uh1,&uh2,&vh1,&vh2);
  /*spoctu kroky*/
  if (xh2-xh1) 
   { deltuH=((uh2-uh1)<<16)/(xh2-xh1);
     deltvH=((vh2-vh1)<<16)/(xh2-xh1);
   } 
   else deltuH=0,deltuH=0;
  /*ted clipuju  x u a jeste v podle velikosti x*/
  /*DULEZITE MIT PRI NESPLNENI PODMINEK CONTINUE A NE RETURN
    JE TO DANO INTERPOLACI V POLICH!!!!!!!*/

  if(xh1<min_x) 
   if(xh2>min_x)
     {uh1=((uh1<<16)+(min_x-xh1)*deltuH)>>16;
      vh1=((vh1<<16)+(min_x-xh1)*deltvH)>>16;
      xh1=min_x;
     }
     else continue;
  if(xh1>max_x) continue;
  if(xh2<min_x) continue;
  
  if(xh2>max_x)
   if(xh1<max_x)
     {uh2=((uh2<<16)+(max_x-xh2)*deltuH)>>16;
      vh2=((vh2<<16)+(max_x-xh2)*deltvH)>>16; 
      xh2=max_x;
     }
     else continue; 
  /*vykreslovani*/      
  uintr=uh1<<16;
  vintr=vh1<<16;
  for(Cntx=xh1;Cntx<(xh2+1);Cntx++)
   {
    color=txtpoly->textura[(uintr>>16)+128*(vintr>>16)];
    vPixScr(Cntx,Cnty,color,(char*)where);
    uintr+=deltuH;
    vintr+=deltvH;
   }
 } //end for cnty    
}  //end proc

void eff3::xchange2(int *a1,int *a2,int *a3,int *a4)
{
 int pom;
 pom=*a1;
 *a1=*a2;
 *a2=pom;
 pom=*a3;
 *a3=*a4;
 *a4=pom;
}

void eff3::xchange(int *a1,int *a2,int *a3,int *a4,int *a5,int *a6)
{
 int pom;
 pom=*a1;
 *a1=*a2;
 *a2=pom;
 pom=*a3;
 *a3=*a4;
 *a4=pom;
 pom=*a5;
 *a5=*a6;
 *a6=pom;
}
